indexing

	description:

		"Scanners for Eiffel parsers"

	library: "Gobo Eiffel Tools Library"
	copyright: "Copyright (c) 1999-2004, Eric Bezault and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2004/10/27 09:14:41 $"
	revision: "$Revision: 1.22 $"

class ET_EIFFEL_SCANNER

inherit

	ET_EIFFEL_SCANNER_SKELETON
		redefine
			read_token
		end

creation

	make, make_with_factory

feature -- Status report

	valid_start_condition (sc: INTEGER): BOOLEAN is
			-- Is `sc' a valid start condition?
		do
			Result := (INITIAL <= sc and sc <= VS3)
		end

feature {NONE} -- Implementation

	yy_build_tables is
			-- Build scanner tables.
		do
			yy_nxt := yy_nxt_template
			yy_chk := yy_chk_template
			yy_base := yy_base_template
			yy_def := yy_def_template
			yy_ec := yy_ec_template
			yy_meta := yy_meta_template
			yy_accept := yy_accept_template
			yy_acclist := yy_acclist_template
		end

	yy_execute_action (yy_act: INTEGER) is
			-- Execute semantic action.
		do
if yy_act <= 51 then
if yy_act <= 26 then
if yy_act <= 13 then
if yy_act <= 7 then
if yy_act <= 4 then
if yy_act <= 2 then
if yy_act = 1 then
	yy_column := yy_column + 1
--|#line 37 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 37")
end

				last_break_end := 0
				last_comment_end := 0
				process_one_char_symbol (text_item (1))
			
else
yy_set_line_column
--|#line 42 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 42")
end

				last_text_count := 1
				last_break_end := text_count
				last_comment_end := 0
				process_one_char_symbol (text_item (1))
			
end
else
if yy_act = 3 then
yy_set_line_column
--|#line 48 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 48")
end

				last_text_count := 1
				last_break_end := 0
				last_comment_end := text_count
				process_one_char_symbol (text_item (1))
			
else
yy_set_line_column
--|#line 54 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 54")
end

				last_text_count := 1
				last_break_end := 0
				last_comment_end := text_count
				process_one_char_symbol ('-')
			
end
end
else
if yy_act <= 6 then
if yy_act = 5 then
	yy_column := yy_column + 2
--|#line 60 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 60")
end

				last_break_end := 0
				last_comment_end := 0
				process_two_char_symbol (text_item (1), text_item (2))
			
else
yy_set_line_column
--|#line 65 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 65")
end

				last_text_count := 2
				last_break_end := text_count
				last_comment_end := 0
				process_two_char_symbol (text_item (1), text_item (2))
			
end
else
yy_set_line_column
--|#line 71 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 71")
end

				last_text_count := 2
				last_break_end := 0
				last_comment_end := text_count
				process_two_char_symbol (text_item (1), text_item (2))
			
end
end
else
if yy_act <= 10 then
if yy_act <= 9 then
if yy_act = 8 then
	yy_end := yy_end - 1
	yy_column := yy_column + 4
--|#line 93 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 93")
end

				last_token := E_ONCE_STRING
				last_literal_start := 1
				last_literal_end := 4
				last_break_end := 0
				last_comment_end := 0
				last_et_keyword_value := ast_factory.new_once_keyword (Current)
			
else
	yy_end := yy_end - 1
yy_set_line_column
--|#line 101 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 101")
end

				last_token := E_ONCE_STRING
				last_literal_start := 1
				last_literal_end := 4
				last_text_count := 4
				last_break_end := text_count
				last_comment_end := 0
				last_et_keyword_value := ast_factory.new_once_keyword (Current)
			
end
else
	yy_end := yy_end - 1
yy_set_line_column
--|#line 110 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 110")
end

				last_token := E_ONCE_STRING
				last_literal_start := 1
				last_literal_end := 4
				last_text_count := 4
				last_break_end := 0
				last_comment_end := text_count
				last_et_keyword_value := ast_factory.new_once_keyword (Current)
			
end
else
if yy_act <= 12 then
if yy_act = 11 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 123 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 123")
end

				last_break_end := 0
				last_comment_end := 0
				process_identifier (text_count)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 128 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 128")
end

				last_text_count := text_count
				break_kind := identifier_break
				more
				set_start_condition (BREAK)
			
end
else
	yy_column := yy_column + 1
--|#line 143 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 143")
end

				last_token := E_FREEOP
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_free_operator_value := ast_factory.new_free_operator (Current)
			
end
end
end
else
if yy_act <= 20 then
if yy_act <= 17 then
if yy_act <= 15 then
if yy_act = 14 then
	yy_column := yy_column + 2
--|#line 144 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 144")
end

				last_token := E_FREEOP
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_free_operator_value := ast_factory.new_free_operator (Current)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 145 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 145")
end

				last_token := E_FREEOP
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_free_operator_value := ast_factory.new_free_operator (Current)
			
end
else
if yy_act = 16 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 146 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 146")
end

				last_token := E_FREEOP
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_free_operator_value := ast_factory.new_free_operator (Current)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 147 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 147")
end

				last_token := E_FREEOP
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_free_operator_value := ast_factory.new_free_operator (Current)
			
end
end
else
if yy_act <= 19 then
if yy_act = 18 then
	yy_end := yy_end - 1
	yy_column := yy_column + 1
--|#line 157 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 157")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := freeop_break
				more
				set_start_condition (BREAK)
			
else
	yy_end := yy_end - 1
	yy_column := yy_column + 2
--|#line 158 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 158")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := freeop_break
				more
				set_start_condition (BREAK)
			
end
else
	yy_end := yy_end - 1
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 159 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 159")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := freeop_break
				more
				set_start_condition (BREAK)
			
end
end
else
if yy_act <= 23 then
if yy_act <= 22 then
if yy_act = 21 then
	yy_end := yy_end - 1
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 160 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 160")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := freeop_break
				more
				set_start_condition (BREAK)
			
else
	yy_end := yy_end - 1
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 161 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 161")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := freeop_break
				more
				set_start_condition (BREAK)
			
end
else
	yy_column := yy_column + 3
--|#line 173 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 173")
end

				last_break_end := 0
				last_comment_end := 0
				process_c1_character_constant (text_item (2))
			
end
else
if yy_act <= 25 then
if yy_act = 24 then
yy_set_line_column
--|#line 178 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 178")
end

				last_text_count := 3
				last_break_end := text_count
				last_comment_end := 0
				process_c1_character_constant (text_item (2))
			
else
yy_set_line_column
--|#line 184 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 184")
end

				last_text_count := 3
				last_break_end := 0
				last_comment_end := text_count
				process_c1_character_constant (text_item (2))
			
end
else
	yy_column := yy_column + 4
--|#line 190 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 190")
end

				last_break_end := 0
				last_comment_end := 0
				process_c2_character_constant (text_item (3))
			
end
end
end
end
else
if yy_act <= 39 then
if yy_act <= 33 then
if yy_act <= 30 then
if yy_act <= 28 then
if yy_act = 27 then
yy_set_line_column
--|#line 195 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 195")
end

				last_text_count := 4
				last_break_end := text_count
				last_comment_end := 0
				process_c2_character_constant (text_item (3))
			
else
yy_set_line_column
--|#line 201 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 201")
end

				last_text_count := 4
				last_break_end := 0
				last_comment_end := text_count
				process_c2_character_constant (text_item (3))
			
end
else
if yy_act = 29 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 208 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 208")
end

				last_token := E_CHARACTER
				last_literal_start := 4
				last_literal_end := text_count - 2
				last_break_end := 0
				last_comment_end := 0
				last_et_character_constant_value := ast_factory.new_c3_character_constant (Current)
			
else
	yy_end := yy_end - 1
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 216 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 216")
end

				last_text_count := text_count
				last_literal_start := 4
				last_literal_end := last_text_count - 2
				break_kind := character_break
				more
				set_start_condition (BREAK)
			
end
end
else
if yy_act <= 32 then
if yy_act = 31 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 225 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 225")
end

					-- Syntax error: invalid character code (too big)
					-- in special character specification %/code/.
				column := column + text_count
				error_handler.report_SCAO_error (filename, current_position)
				last_et_position_value := current_position
				column := column - text_count
				last_token := E_CHARERR
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 234 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 234")
end

					-- Syntax error: missing character / at end
					-- of special character specification %/code/.
				column := column + text_count
				error_handler.report_SCAS_error (filename, current_position)
				last_et_position_value := current_position
				column := column - text_count
				last_token := E_CHARERR
			
end
else
	yy_column := yy_column + 3
--|#line 243 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 243")
end

					-- Syntax error: missing ASCII code in
					-- special character specification %/code/.
				column := column + 3
				error_handler.report_SCAC_error (filename, current_position)
				last_et_position_value := current_position
				column := column - 3
				last_token := E_CHARERR
			
end
end
else
if yy_act <= 36 then
if yy_act <= 35 then
if yy_act = 34 then
	yy_column := yy_column + 2
--|#line 252 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 252")
end

					-- Syntax error: missing character between quotes.
				column := column + 1
				error_handler.report_SCQQ_error (filename, current_position)
				last_et_position_value := current_position
				column := column - 1
				last_token := E_CHARERR
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 260 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 260")
end

					-- Syntax error: missing quote at
					-- end of character constant.
				column := column + text_count
				error_handler.report_SCEQ_error (filename, current_position)
				last_et_position_value := current_position
				column := column - text_count
				last_token := E_CHARERR
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 273 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 273")
end

				last_token := E_STRFREEOP
				last_literal_start := 2
				last_literal_end := text_count - 1
				last_break_end := 0
				last_comment_end := 0
				last_et_manifest_string_value := ast_factory.new_regular_manifest_string (Current)
			
end
else
if yy_act <= 38 then
if yy_act = 37 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 281 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 281")
end

				last_text_count := text_count
				last_literal_start := 2
				last_literal_end := last_text_count - 1
				break_kind := str_freeop_break
				more
				set_start_condition (BREAK)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 290 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 290")
end

					-- Regular manifest string.
				last_break_end := 0
				last_comment_end := 0
				process_regular_manifest_string (text_count)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 296 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 296")
end

					-- Regular manifest string.
				last_text_count := text_count
				break_kind := string_break
				more
				set_start_condition (BREAK)
			
end
end
end
else
if yy_act <= 45 then
if yy_act <= 42 then
if yy_act <= 41 then
if yy_act = 40 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 304 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 304")
end

					-- Verbatim string.
				verbatim_marker := text_substring (2, text_count - 1)
				set_start_condition (VS1)
			
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 312 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 312")
end

				verbatim_open_white_characters := text
				last_literal_start := 1
				last_literal_end := 0
				set_start_condition (VS2)
			
end
else
	yy_column := yy_column + 1
--|#line 318 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 318")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_et_position_value := current_position
				set_start_condition (INITIAL)
			
end
else
if yy_act <= 44 then
if yy_act = 43 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 334 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 334")
end

				if is_verbatim_string_closer (last_literal_end + 1, text_count - 1) then
					last_token := E_STRING
					last_break_end := 0
					last_comment_end := 0
					last_et_manifest_string_value := ast_factory.new_verbatim_string (verbatim_marker, verbatim_open_white_characters,
						text_substring (last_literal_end + 1, text_count - verbatim_marker.count - 2), Current)
					verbatim_marker := Void
					verbatim_open_white_characters := Void
					set_start_condition (INITIAL)
				else
					more
					set_start_condition (VS3)
				end
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 349 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 349")
end

				if is_verbatim_string_closer (last_literal_end + 1, text_count - 1) then
					verbatim_close_white_characters := text_substring (last_literal_end + 1, text_count - verbatim_marker.count - 2)
					last_text_count := text_count
					break_kind := str_verbatim_break
					more
					set_start_condition (BREAK)
				else
					more
					set_start_condition (VS3)
				end
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 361 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 361")
end

				more
				set_start_condition (VS3)
			
end
end
else
if yy_act <= 48 then
if yy_act <= 47 then
if yy_act = 46 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 365 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 365")
end

				more
				last_literal_end := text_count - 2
			
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 369 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 369")
end

				more
				last_literal_end := text_count - 1
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 373 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 373")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_et_position_value := current_position
				set_start_condition (INITIAL)
			
end
else
if yy_act <= 50 then
if yy_act = 49 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 389 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 389")
end

				more
				last_literal_end := text_count - 2
				set_start_condition (VS2)
			
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 394 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 394")
end

				more
				last_literal_end := text_count - 1
				set_start_condition (VS2)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 399 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 399")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_et_position_value := current_position
				set_start_condition (INITIAL)
			
end
end
end
end
end
else
if yy_act <= 76 then
if yy_act <= 64 then
if yy_act <= 58 then
if yy_act <= 55 then
if yy_act <= 53 then
if yy_act = 52 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 413 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 413")
end

					-- Manifest string with special characters.
				last_token := E_STRING
				last_literal_start := 2
				last_literal_end := text_count - 1
				last_break_end := 0
				last_comment_end := 0
				last_et_manifest_string_value := ast_factory.new_special_manifest_string (Current)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 422 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 422")
end

					-- Manifest string with special characters.
				last_text_count := text_count
				last_literal_start := 2
				last_literal_end := last_text_count - 1
				break_kind := str_special_break
				more
				set_start_condition (BREAK)
			
end
else
if yy_act = 54 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 431 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 431")
end

					-- Manifest string with special characters which may be made
					-- up of several lines or may include invalid characters.
					-- Keep track of current line and column.
				ms_line := line
				ms_column := column
				more
				set_start_condition (MS)
			
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 442 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 442")
end

					-- Multi-line manifest string.
				more
				set_start_condition (MSN)
			
end
end
else
if yy_act <= 57 then
if yy_act = 56 then
	yy_end := yy_start + yy_more_len + 2
	yy_column := yy_column + 2
--|#line 447 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 447")
end

					-- Multi-line manifest string.

					-- Syntax error: no space allowed after character
					-- % at end of line in multi-line manifest strings.
				column := yy_column - 1
				line := yy_line
				error_handler.report_SSNS_error (filename, current_position)
				column := ms_column
				line := ms_line
				more
				set_start_condition (MSN1)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 460 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 460")
end

				more
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 463 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 463")
end

					-- Syntax error: invalid character code (too big) in special
					-- character specification %/code/ in manifest string.
				column := yy_column
				line := yy_line
				error_handler.report_SSAO_error (filename, current_position)
				last_et_position_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
end
end
else
if yy_act <= 61 then
if yy_act <= 60 then
if yy_act = 59 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 475 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 475")
end

					-- Syntax error: missing character / at end of special
					-- character specification %/code/ in manifest string.
				column := yy_column
				line := yy_line
				error_handler.report_SSAS_error (filename, current_position)
				last_et_position_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
else
	yy_column := yy_column + 2
--|#line 487 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 487")
end

					-- Syntax error: missing ASCII code in special character
					-- specification %/code/ in manifest string.
				column := yy_column
				line := yy_line
				error_handler.report_SSAC_error (filename, current_position)
				last_et_position_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
end
else
	yy_column := yy_column + 2
--|#line 499 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 499")
end

					-- Syntax error: special character specification
					-- %l where l is a letter code should be in
					-- upper-case in manifest strings.
				column := yy_column - 1
				line := yy_line
				error_handler.report_SSCU_error (filename, current_position)
				column := ms_column
				line := ms_line
				more
			
end
else
if yy_act <= 63 then
if yy_act = 62 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 510 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 510")
end

				more
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 513 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 513")
end

				last_token := E_STRING
				last_literal_start := 2
				last_literal_end := text_count - 1
				last_break_end := 0
				last_comment_end := 0
				last_et_manifest_string_value := ast_factory.new_special_manifest_string (Current)
				set_start_condition (INITIAL)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 522 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 522")
end

				last_text_count := text_count
				last_literal_start := 2
				last_literal_end := last_text_count - 1
				break_kind := str_special_break
				more
				set_start_condition (BREAK)
			
end
end
end
else
if yy_act <= 70 then
if yy_act <= 67 then
if yy_act <= 66 then
if yy_act = 65 then
	yy_column := yy_column + 2
--|#line 530 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 530")
end

					-- Syntax error: Invalid special character
					-- in manifest strings.
				column := yy_column - 1
				line := yy_line
				error_handler.report_SSSC_error (filename, current_position)
				column := ms_column
				line := ms_line
				more
			
else
	yy_column := yy_column + 1
--|#line 540 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 540")
end

					-- Syntax error: invalid special character
					-- %l in manifest strings.
				column := yy_column
				line := yy_line
				error_handler.report_SSSC_error (filename, current_position)
				last_et_position_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
end
else
	yy_line := yy_line + 1
	yy_column := 1
--|#line 552 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 552")
end

					-- Syntax error: Invalid new-line in manifest string.
				column := 1
				line := yy_line
				error_handler.report_SSNL_error (filename, current_position)
				last_et_position_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
end
else
if yy_act <= 69 then
if yy_act = 68 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 578 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 578")
end

				more
				set_start_condition (MSN)
			
else
	yy_column := yy_column + 1
--|#line 582 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 582")
end

					-- Should never happen.
				last_token := E_STRERR
				last_et_position_value := current_position
				set_start_condition (INITIAL)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 597 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 597")
end

				more
				set_start_condition (MS)
			
end
end
else
if yy_act <= 73 then
if yy_act <= 72 then
if yy_act = 71 then
	yy_line := yy_line + 1
	yy_column := 1
--|#line 601 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 601")
end

					-- Syntax error: empty line in middle of
					-- multi-line manifest string.
				column := 1
				line := yy_line - 1
				error_handler.report_SSEL_error (filename, current_position)
				column := ms_column
				line := ms_line
				more
			
else
	yy_column := yy_column + 1
--|#line 611 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 611")
end

					-- Syntax error: missing character % at beginning
					-- of line in multi-line manifest string.
				column := yy_column - 1
				line := yy_line
				error_handler.report_SSNP_error (filename, current_position)
				last_et_position_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 640 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 640")
end

				last_token := E_BIT
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_bit_constant_value := ast_factory.new_bit_constant (Current)
			
end
else
if yy_act <= 75 then
if yy_act = 74 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 648 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 648")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := bit_break
				more
				set_start_condition (BREAK)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 660 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 660")
end

				last_token := E_INTEGER
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_integer_constant_value := ast_factory.new_regular_integer_constant (Current)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 668 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 668")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := integer_break
				more
				set_start_condition (BREAK)
			
end
end
end
end
else
if yy_act <= 89 then
if yy_act <= 83 then
if yy_act <= 80 then
if yy_act <= 78 then
if yy_act = 77 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 676 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 676")
end

				last_token := E_INTEGER
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_integer_constant_value := ast_factory.new_underscored_integer_constant (Current)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 684 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 684")
end

					-- Syntax error: an underscore may not be
					-- the first character of an integer.
				error_handler.report_SIFU_error (filename, current_position)
				last_token := E_INTEGER
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_integer_constant_value := ast_factory.new_underscored_integer_constant (Current)
			
end
else
if yy_act = 79 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 695 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 695")
end

					-- Syntax error: an underscore must be followed
					-- by three digits and there must not be any
					-- consecutive group of four digits.
				error_handler.report_SITD_error (filename, current_position)
				last_token := E_INTEGER
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_integer_constant_value := ast_factory.new_underscored_integer_constant (Current)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 707 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 707")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := uinteger_break
				more
				set_start_condition (BREAK)
			
end
end
else
if yy_act <= 82 then
if yy_act = 81 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 715 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 715")
end

				last_token := E_INTEGER
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_integer_constant_value := ast_factory.new_hexadecimal_integer_constant (Current)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 723 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 723")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := hinteger_break
				more
				set_start_condition (BREAK)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 735 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 735")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := real_break
				more
				set_start_condition (BREAK)
			
end
end
else
if yy_act <= 86 then
if yy_act <= 85 then
if yy_act = 84 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 736 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 736")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := real_break
				more
				set_start_condition (BREAK)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 737 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 737")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := real_break
				more
				set_start_condition (BREAK)
			
end
else
	yy_end := yy_end - 1
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 745 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 745")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_real_constant_value := ast_factory.new_regular_real_constant (Current)
			
end
else
if yy_act <= 88 then
if yy_act = 87 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 746 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 746")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_real_constant_value := ast_factory.new_regular_real_constant (Current)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 747 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 747")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_real_constant_value := ast_factory.new_regular_real_constant (Current)
			
end
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 758 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 758")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := ureal_break
				more
				set_start_condition (BREAK)
			
end
end
end
else
if yy_act <= 95 then
if yy_act <= 92 then
if yy_act <= 91 then
if yy_act = 90 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 759 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 759")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := ureal_break
				more
				set_start_condition (BREAK)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 760 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 760")
end

				last_text_count := text_count
				last_literal_start := 1
				last_literal_end := last_text_count
				break_kind := ureal_break
				more
				set_start_condition (BREAK)
			
end
else
	yy_end := yy_end - 1
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 768 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 768")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_real_constant_value := ast_factory.new_underscored_real_constant (Current)
			
end
else
if yy_act <= 94 then
if yy_act = 93 then
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 769 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 769")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_real_constant_value := ast_factory.new_underscored_real_constant (Current)
			
else
	yy_column := yy_column + yy_end - yy_start - yy_more_len
--|#line 770 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 770")
end

		-- The first regexp of this group uses a trailing context
		-- to make sure that an integer followed by two dots is
		-- not recognized as a real followed by a dot.
				last_token := E_REAL
				last_literal_start := 1
				last_literal_end := text_count
				last_break_end := 0
				last_comment_end := 0
				last_et_real_constant_value := ast_factory.new_underscored_real_constant (Current)
			
end
else
yy_set_line_column
--|#line 785 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 785")
end

				last_literal_start := 1
				last_literal_end := 0
				last_text_count := 0
				last_break_end := text_count
				last_comment_end := 0
				last_et_break_value := ast_factory.new_break (Current)
				last_token := E_BREAK
			
end
end
else
if yy_act <= 98 then
if yy_act <= 97 then
if yy_act = 96 then
yy_set_line_column
--|#line 795 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 795")
end

				last_literal_start := 1
				last_literal_end := 0
				last_text_count := 0
				last_break_end := 0
				last_comment_end := text_count
				last_et_break_value := ast_factory.new_comment (Current)
				last_token := E_BREAK
			
else
yy_set_line_column
--|#line 806 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 806")
end

				last_break_end := text_count
				last_comment_end := 0
				process_break
				set_start_condition (INITIAL)
			
end
else
yy_set_line_column
--|#line 812 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 812")
end

				last_break_end := 0
				last_comment_end := text_count
				process_break
				set_start_condition (INITIAL)
			
end
else
if yy_act <= 100 then
if yy_act = 99 then
	yy_column := yy_column + 1
--|#line 818 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 818")
end

					-- Should never happen.
				less (0)
				last_break_end := 0
				last_comment_end := 0
				process_break
				set_start_condition (INITIAL)
			
else
	yy_column := yy_column + 1
--|#line 839 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 839")
end

				last_token := E_UNKNOWN
				last_et_position_value := current_position
			
end
else
yy_set_line_column
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end
last_token := yyError_token
fatal_error ("scanner jammed")
end
end
end
end
end
end
		end

	yy_execute_eof_action (yy_sc: INTEGER) is
			-- Execute EOF semantic action.
		do
			inspect yy_sc
when 0 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end
terminate
when 1 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- Should never happen.
				last_break_end := 0
				last_comment_end := 0
				process_break
				set_start_condition (INITIAL)
			
when 2 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- Syntax error: missing double quote at
					-- end of manifest string.
				column := yy_column
				line := yy_line
				error_handler.report_SSEQ_error (filename, current_position)
				last_et_position_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
when 3 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- Syntax error: missing character % at beginning
					-- of line in multi-line manifest string.
				column := yy_column
				line := yy_line
				error_handler.report_SSNP_error (filename, current_position)
				last_et_position_value := current_position
				column := ms_column
				line := ms_line
				last_token := E_STRERR
				set_start_condition (INITIAL)
			
when 4 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- Should never happen.
				last_token := E_STRERR
				last_et_position_value := current_position
				set_start_condition (INITIAL)
			
when 5 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_et_position_value := current_position
				set_start_condition (INITIAL)
			
when 6 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_et_position_value := current_position
				set_start_condition (INITIAL)
			
when 7 then
--|#line 0 "et_eiffel_scanner.l"
debug ("GELEX")
	std.error.put_line ("Executing scanner user-code from file 'et_eiffel_scanner.l' at line 0")
end

					-- No final bracket-double-quote.
				last_token := E_STRERR
				last_et_position_value := current_position
				set_start_condition (INITIAL)
			
			else
				terminate
			end
		end

feature {NONE} -- Table templates

	yy_nxt_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,   18,   19,   20,   19,   21,   22,   23,   18,   24,
			   25,   21,   21,   21,   26,   27,   28,   29,   30,   31,
			   31,   31,   31,   32,   33,   21,   34,   35,   36,   36,
			   36,   36,   36,   36,   36,   37,   36,   21,   38,   21,
			   39,   36,   36,   36,   36,   36,   41,   42,   41,   41,
			   42,   41,   45,   65,   66,   46,  350,   47,   43,   45,
			  347,   43,   46,  342,   47,   49,   50,   49,   49,   50,
			   49,   51,   65,   66,   51,   53,   54,   53,   53,   54,
			   53,   56,   57,   56,   56,   57,   56,   59,   60,   61,
			  333,   62,   59,   60,   61,  324,   62,   67,   67,   67,

			   67,   67,   67,   69,   69,   69,   80,   80,   80,   68,
			  336,   82,   68,   83,  308,   70,   72,   73,   74,   73,
			   77,   77,   77,  325,   63,   84,   84,   84,  155,   63,
			   78,   78,   78,  324,   69,   69,   69,   85,  106,  156,
			  107,   69,   69,   69,  135,  136,   70,   75,   86,   86,
			   69,   69,   69,   70,  117,  118,  117,   86,  125,  126,
			  119,  127,   70,   86,   86,   87,   87,   87,   87,   87,
			   87,   88,   88,   88,  120,  121,  120,  122,  123,  122,
			  323,   92,   92,   89,   90,  287,   91,   91,   92,   92,
			   92,   92,  106,  353,  107,   69,   69,   69,   93,   98,

			  353,   69,   69,   69,  280,   94,  353,   70,  304,   95,
			   98,   93,  300,   70,   69,   69,   69,   86,   86,   96,
			   96,   96,  137,  136,   86,   86,   70,   96,   96,   96,
			  105,   97,  102,  102,  102,  105,   72,   86,   74,   97,
			  102,  102,  102,  265,  103,  108,  108,  108,  125,  132,
			  105,  133,  103,  124,   67,   67,   67,  109,  179,   99,
			  147,  147,  147,  149,  149,  149,   68,   75,  177,  180,
			   99,  110,  111,  112,  113,  110,  114,  110,  114,  110,
			  114,  114,  110,  110,  110,  110,  115,  110,  110,  110,
			  110,  110,  110,  110,  114,  110,  114,  110,  114,  114,

			  114,  110,  110,  114,  114,  110,  110,  110,  110,  110,
			  110,  116,  116,  116,  116,  116,  128,  125,  129,  299,
			  127,  128,  131,  129,  261,  127,   69,   69,   69,  139,
			  139,  139,  178,   71,  353,   71,   98,  141,   70,   74,
			  244,  140,  145,  146,  145,  178,   72,   98,   74,   80,
			   80,   80,  244,  130,  153,  153,  153,  244,  130,  157,
			  157,  157,  170,  170,  244,  106,  154,  107,  142,  125,
			  126,  158,  127,  278,  353,  135,  136,   75,  159,  159,
			  159,  182,  183,  182,  182,  184,  182,  353,  131,  126,
			  160,  127,  277,  161,  161,  161,  161,  161,  161,  171,

			  171,  171,  174,  174,  174,  137,  136,  162,  102,  102,
			  102,  172,  143,  191,  175,  143,  163,  165,  165,  165,
			  103,  120,  121,  120,  192,  143,  108,  108,  108,  166,
			  211,  211,  167,  167,  167,  167,  167,  167,  109,  185,
			  186,  187,  188,  188,  188,  235,  168,  169,  169,  170,
			  170,  170,  170,  117,  118,  117,  122,  123,  122,  119,
			  128,  125,  129,  195,  127,   74,  353,  174,  174,  174,
			  128,  131,  129,  230,  127,  125,  132,  230,  133,  175,
			  124,  155,  176,  176,  176,  176,  176,  176,  131,  132,
			  230,  133,  156,  124,  189,  189,  189,  130,  193,  193,

			  193,  200,  200,  200,  265,  177,  190,  130,  218,  218,
			  194,  145,  146,  145,  105,  141,  179,   74,  196,  197,
			  198,  199,  199,  199,  145,  146,  145,  180,   72,  177,
			   74,  201,  201,  201,  191,  153,  153,  153,  155,  155,
			  155,  258,  258,  202,  105,  192,  142,  154,  305,  305,
			   68,  157,  157,  157,  222,  222,  222,  317,  317,   75,
			  203,  222,  106,  158,  107,  244,  223,  204,  205,  206,
			  207,  207,  207,  210,  210,  210,  210,  210,  210,  213,
			  213,  213,  213,  213,  213,  159,  159,  159,  220,  220,
			  221,  221,  221,  221,  221,  221,  249,  160,  327,  327,

			  215,  215,  215,  215,  215,  215,  353,  250,  174,  174,
			  174,  251,  230,  225,  216,  244,   98,  241,  274,  353,
			  175,  275,  252,  217,  174,  174,  174,   98,  182,  183,
			  182,  244,  276,  179,  179,  179,  175,  279,  143,  224,
			  224,  224,  224,  224,  224,  103,  226,  227,  228,  229,
			  229,  229,  253,  253,  253,  253,  253,  253,  303,  303,
			  303,  143,  177,  230,  185,  186,  187,  188,  188,  188,
			  230,  232,  232,  232,  232,  233,  234,  191,  191,  191,
			  235,  235,  235,  212,  212,  212,  212,  212,  212,   70,
			  329,  329,  236,  143,  196,  197,  198,  199,  199,  199,

			  143,  238,  238,  238,  238,  239,  240,  201,  201,  201,
			  242,  242,  242,  256,  256,  256,  256,  256,  256,  202,
			  338,  338,  243,  244,  246,  246,  246,  246,  247,  248,
			  159,  159,  159,  257,  257,  257,  257,  257,  257,  345,
			  345,  193,  160,  189,  230,  254,  254,  254,  254,  254,
			  254,  260,  260,  260,  260,  260,  260,  219,  219,  219,
			  219,  219,  219,  231,  231,  231,  231,  230,  255,  261,
			  261,  261,  143,  240,  240,  240,  240,  240,  242,  242,
			  242,  262,  174,  249,  263,  263,  263,  263,  263,  263,
			  243,  249,  249,  249,  250,  251,  171,  214,  159,  251,

			  251,  251,  209,  154,  208,  203,  252,  264,  174,  174,
			  174,  158,  284,  284,  284,  284,  284,  284,  139,  108,
			  175,  181,  104,  266,  266,  266,  266,  266,  266,  285,
			  285,  285,  285,  285,  285,  286,  286,  286,  286,  286,
			  286,  234,  234,  234,  234,  101,  177,  267,  267,  267,
			   96,  268,  259,  259,  259,  259,  259,  259,   88,  269,
			  291,  291,  291,  291,  291,  291,  293,  293,  293,  293,
			  293,  293,  174,  174,  174,  275,  296,  296,  296,   98,
			  297,  150,  152,  150,  175,  295,  276,  144,  298,  138,
			   98,  105,  226,  227,  228,  229,  229,  229,  105,  271,

			  271,  271,  271,  272,  273,  280,  280,  280,  301,   85,
			   95,  105,  273,  273,  273,  273,  273,  281,  301,  302,
			  253,  253,  253,  253,  253,  253,  275,  275,  275,  302,
			  237,  237,  237,  237,  282,  159,  159,  159,  202,  307,
			  307,  307,  307,  307,  307,  104,  101,  160,   86,  353,
			  283,  283,  283,  283,  283,  283,  353,  353,  308,  308,
			  308,  313,  313,  313,  313,  313,  313,  353,  353,  353,
			  309,  353,  353,  255,  287,  287,  287,  314,  314,  314,
			  314,  314,  314,  301,  301,  301,  288,  310,  353,  289,
			  289,  289,  289,  289,  289,  243,  163,  316,  316,  316,

			  316,  316,  316,  353,  296,  296,  296,  353,  297,  353,
			  353,  353,  290,  261,  261,  261,  298,  306,  306,  306,
			  306,  306,  306,  353,  353,  262,  353,  353,  292,  292,
			  292,  292,  292,  292,  353,  280,  280,  280,  326,  326,
			  326,  326,  326,  326,  173,  173,  173,  281,  353,  173,
			  173,  264,  165,  165,  165,  331,  331,  331,  331,  331,
			  331,  353,  353,  353,  166,  353,  353,  286,  286,  286,
			  286,  286,  286,  353,  308,  308,  308,  333,  333,  333,
			  353,  294,  159,  159,  159,  353,  309,  353,  353,  334,
			  240,  240,  240,  240,  160,  353,  353,  306,  306,  306,

			  306,  306,  306,  332,  335,  335,  335,  335,  335,  335,
			  353,  353,  217,  315,  315,  315,  315,  315,  315,  353,
			  255,  280,  280,  280,  328,  328,  328,  328,  328,  328,
			  324,  324,  324,  281,  340,  353,  286,  286,  286,  286,
			  286,  286,  298,  308,  308,  308,  245,  245,  245,  245,
			  311,  287,  287,  287,  353,  309,  330,  330,  330,  330,
			  330,  330,  353,  288,  353,  353,  312,  312,  312,  312,
			  312,  312,  353,  342,  342,  342,  347,  347,  347,  353,
			  353,  255,  353,  353,  353,  343,  353,  353,  348,  290,
			  261,  261,  261,  344,  344,  344,  344,  344,  344,  353,

			  353,  353,  262,  353,  353,  315,  315,  315,  315,  315,
			  315,  353,  353,  353,  264,  314,  314,  314,  314,  314,
			  314,  339,  339,  339,  339,  339,  339,  353,  264,  319,
			  319,  319,  346,  346,  346,  346,  346,  346,  353,  353,
			  353,  320,  353,  353,  321,  321,  321,  321,  321,  321,
			  350,  350,  350,  100,  100,  100,  353,  353,  322,  287,
			  287,  287,  351,  353,  100,  248,  248,  248,  248,  353,
			  353,  288,  353,  353,  330,  330,  330,  330,  330,  330,
			  212,  212,  353,  353,  212,  212,  212,  353,  290,  219,
			  219,  353,  353,  219,  219,  219,  353,  290,  308,  308,

			  308,  259,  259,  353,  353,  259,  259,  259,  353,  353,
			  309,  353,  353,  337,  337,  337,  337,  337,  337,  270,
			  270,  270,  270,  273,  273,  273,  273,  332,  274,  274,
			  274,  274,  279,  279,  279,  279,  217,  308,  308,  308,
			  306,  306,  353,  353,  306,  306,  306,  353,  353,  309,
			  353,  353,  341,  341,  341,  341,  341,  341,  315,  315,
			  353,  353,  315,  315,  315,  328,  328,  353,  353,  328,
			  328,  328,  353,  353,  353,  255,  347,  347,  347,  330,
			  330,  353,  353,  330,  330,  330,  353,  353,  348,  353,
			  353,  349,  349,  349,  349,  349,  349,  339,  339,  353,

			  353,  339,  339,  339,  346,  346,  353,  353,  346,  346,
			  346,  353,  353,  353,  264,  308,  308,  308,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  309,  353,  353,
			  326,  326,  326,  326,  326,  326,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  255,  350,  350,  350,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  351,  353,  353,  352,
			  352,  352,  352,  352,  352,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  290,  347,  347,  347,  353,  353,  353,  353,

			  353,  353,  353,  353,  353,  348,  353,  353,  335,  335,
			  335,  335,  335,  335,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  264,  350,  350,  350,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  351,  353,  353,  344,  344,  344,
			  344,  344,  344,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  290,   40,   40,   40,   40,   40,   40,   40,   40,   40,
			   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
			   40,   40,   40,   40,   40,   44,   44,   44,   44,   44,

			   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
			   44,   44,   44,   44,   44,   44,   44,   44,   44,   48,
			   48,   48,   48,   48,   48,   48,   48,   48,   48,   48,
			   48,   48,   48,   48,   48,   48,   48,   48,   48,   48,
			   48,   48,   48,   52,   52,   52,   52,   52,   52,   52,
			   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
			   52,   52,   52,   52,   52,   52,   52,   55,   55,   55,
			   55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
			   55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
			   55,   58,   58,   58,   58,   58,   58,   58,   58,   58,

			   58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
			   58,   58,   58,   58,   58,   64,   64,   64,   64,   64,
			   64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
			   64,   64,   64,   64,   64,   64,   64,   64,   64,   71,
			   71,  353,   71,   71,   71,   71,   71,   71,   71,   71,
			   71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
			   71,   71,   71,   76,   76,   76,   76,  353,  353,   76,
			   76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
			   76,   76,   76,   76,   76,   76,   76,   79,   79,   79,
			   79,  353,  353,   79,   79,   79,   79,   79,   79,   79,

			   79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
			   79,   81,   81,  353,   81,   81,   81,   81,   81,   81,
			   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
			   81,   81,   81,   81,   81,   98,   98,   98,  353,  353,
			  353,  353,  353,   98,  353,  353,   98,   98,   98,  353,
			  353,   98,   98,   98,   98,   98,   98,   98,  105,  105,
			  353,  105,  105,  105,  105,  105,  105,  105,  105,  105,
			  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
			  105,  105,  124,  124,  124,  124,  124,  124,  124,  124,
			  124,  124,  124,  124,  124,  124,  124,  124,  124,  124,

			  124,  124,  124,  124,  124,  124,  130,  130,  130,  130,
			  130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
			  130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
			  134,  134,  134,  134,  134,  134,  134,  134,  134,  134,
			  134,  134,  134,  134,  134,  134,  134,  134,  134,  134,
			  134,  134,  134,  134,   73,   73,  353,   73,   73,   73,
			   73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
			   73,   73,   73,   73,   73,   73,   73,   73,  143,  143,
			  143,  143,  353,  353,  353,  143,  353,  353,  353,  143,
			  143,  143,  353,  353,  143,  148,  148,  148,  148,  353,

			  353,  148,  148,  148,  148,  148,  148,  353,  353,  353,
			  148,  148,  151,  151,  353,  151,  151,  151,  151,  151,
			  151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
			  151,  151,  151,  151,  151,  151,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			   85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
			  164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
			  353,  164,  164,  164,  164,  164,  164,  164,  164,  164,
			  164,  164,  164,  164,  104,  104,  104,  104,  104,  104,
			  104,  104,  104,  104,  104,  104,  104,  104,  104,  104,

			  104,  104,  104,  104,  104,  104,  104,  104,  105,  105,
			  105,  105,  353,  353,  353,  105,  353,  353,  353,  105,
			  105,  105,  353,  353,  105,  138,  138,  138,  138,  138,
			  138,  138,  138,  138,  138,  138,  138,  138,  138,  138,
			  138,  138,  138,  138,  138,  138,  138,  138,  138,  143,
			  143,  353,  143,  143,  143,  143,  143,  143,  143,  143,
			  143,  143,  143,  143,  143,  143,  143,  143,  143,  143,
			  143,  143,  143,  148,  148,  148,  148,  353,  353,  148,
			  148,  148,  148,  148,  148,  148,  148,  148,  148,  148,
			  148,  148,  148,  148,  148,  148,  148,  177,  177,  177,

			  353,  353,  353,  353,  353,  177,  353,  353,  177,  177,
			  177,  353,  353,  353,  353,  353,  353,  353,  353,  177,
			  208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
			  208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
			  208,  208,  208,  208,  209,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
			  209,  209,  209,  209,  209,  209,  209,  209,  241,  241,
			  241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
			  241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
			  241,  241,  164,  164,  164,  164,  164,  164,  164,  164,

			  164,  164,  353,  164,  164,  164,  164,  164,  164,  164,
			  164,  164,  164,  164,  164,  164,  277,  277,  277,  277,
			  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
			  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
			  318,  318,  318,  318,  318,  318,  318,  318,  318,  318,
			  353,  318,  318,  318,  318,  318,  318,  318,  318,  318,
			  318,  318,  318,  318,  323,  323,  323,  323,  323,  323,
			  323,  323,  323,  323,  323,  323,  323,  323,  323,  323,
			  323,  323,  323,  323,  323,  323,  323,  323,   17,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,

			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353, yy_Dummy>>)
		end

	yy_chk_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    3,    3,    3,    4,
			    4,    4,    5,   15,   15,    5,  351,    5,    3,    6,
			  348,    4,    6,  343,    6,    7,    7,    7,    8,    8,
			    8,    7,   16,   16,    8,    9,    9,    9,   10,   10,
			   10,   11,   11,   11,   12,   12,   12,   13,   13,   13,
			  334,   13,   14,   14,   14,  323,   14,   19,   19,   19,

			   20,   20,   20,   21,   21,   21,   24,   24,   24,   19,
			  320,   25,   20,   25,  309,   21,   22,   22,   22,   22,
			   23,   23,   23,  304,   13,   26,   26,   26,   85,   14,
			   23,   23,   23,  299,   28,   28,   28,   26,   44,   85,
			   44,   32,   32,   32,   64,   64,   28,   22,   28,   26,
			   27,   27,   27,   32,   49,   49,   49,   28,   58,   58,
			   49,   58,   27,   27,   32,   27,   27,   27,   27,   27,
			   27,   29,   29,   29,   53,   53,   53,   56,   56,   56,
			  298,   31,   31,   29,   29,  288,   29,   29,   29,   29,
			   29,   29,  105,   31,  105,   33,   33,   33,   29,   98,

			   31,   34,   34,   34,  281,   29,   31,   33,  279,   29,
			   98,   29,  274,   34,   35,   35,   35,   33,   33,   36,
			   36,   36,   66,   66,   34,   34,   35,   37,   37,   37,
			  273,   36,   41,   41,   41,  271,   71,   35,   71,   37,
			   42,   42,   42,  220,   41,   46,   46,   46,   63,   63,
			  270,   63,   42,   63,   67,   67,   67,   46,  104,   37,
			   76,   76,   76,   78,   78,   78,   67,   71,  220,  104,
			   37,   47,   47,   47,   47,   47,   47,   47,   47,   47,
			   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
			   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,

			   47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
			   47,   47,   47,   47,   47,   47,   59,   59,   59,  269,
			   59,   61,   61,   61,  262,   61,   69,   69,   69,   72,
			   72,   72,   99,   73,  204,   73,   99,   73,   69,   73,
			  204,   72,   75,   75,   75,   99,   75,   99,   75,   79,
			   79,   79,  248,   59,   84,   84,   84,  246,   61,   86,
			   86,   86,   92,   92,  245,  114,   84,  114,   73,  124,
			  124,   86,  124,  244,   92,  134,  134,   75,   87,   87,
			   87,  111,  111,  111,  113,  113,  113,   92,  126,  126,
			   87,  126,  243,   87,   87,   87,   87,   87,   87,   93,

			   93,   93,  100,  100,  100,  136,  136,   87,  102,  102,
			  102,   93,  240,  138,  100,  238,   87,   90,   90,   90,
			  102,  120,  120,  120,  138,  237,  106,  106,  106,   90,
			  162,  162,   90,   90,   90,   90,   90,   90,  106,  115,
			  115,  115,  115,  115,  115,  236,   90,   91,   91,   91,
			   91,   91,   91,  117,  117,  117,  122,  122,  122,  117,
			  128,  128,  128,  143,  128,  143,   91,   95,   95,   95,
			  129,  129,  129,  234,  129,  130,  130,  232,  130,   95,
			  130,  156,   95,   95,   95,   95,   95,   95,  132,  132,
			  231,  132,  156,  132,  133,  133,  133,  128,  141,  141,

			  141,  148,  148,  148,  221,   95,  133,  129,  168,  168,
			  141,  142,  142,  142,  229,  142,  180,  142,  144,  144,
			  144,  144,  144,  144,  145,  145,  145,  180,  145,  221,
			  145,  150,  150,  150,  192,  153,  153,  153,  155,  155,
			  155,  216,  216,  150,  227,  192,  142,  153,  282,  282,
			  155,  157,  157,  157,  173,  173,  173,  294,  294,  145,
			  152,  223,  230,  157,  230,  207,  173,  152,  152,  152,
			  152,  152,  152,  161,  161,  161,  161,  161,  161,  163,
			  163,  163,  163,  163,  163,  167,  167,  167,  169,  169,
			  169,  169,  169,  169,  170,  170,  208,  167,  310,  310,

			  167,  167,  167,  167,  167,  167,  170,  208,  177,  177,
			  177,  209,  233,  178,  167,  205,  178,  202,  233,  170,
			  177,  241,  209,  167,  176,  176,  176,  178,  182,  182,
			  182,  247,  241,  179,  179,  179,  176,  247,  199,  176,
			  176,  176,  176,  176,  176,  179,  181,  181,  181,  181,
			  181,  181,  210,  210,  210,  210,  210,  210,  278,  278,
			  278,  197,  176,  185,  185,  185,  185,  185,  185,  185,
			  187,  187,  187,  187,  187,  187,  187,  191,  191,  191,
			  195,  195,  195,  211,  211,  211,  211,  211,  211,  191,
			  311,  311,  195,  196,  196,  196,  196,  196,  196,  196,

			  198,  198,  198,  198,  198,  198,  198,  201,  201,  201,
			  203,  203,  203,  213,  213,  213,  213,  213,  213,  201,
			  322,  322,  203,  206,  206,  206,  206,  206,  206,  206,
			  212,  212,  212,  215,  215,  215,  215,  215,  215,  332,
			  332,  194,  212,  190,  188,  212,  212,  212,  212,  212,
			  212,  217,  217,  217,  217,  217,  217,  218,  218,  218,
			  218,  218,  218,  386,  386,  386,  386,  186,  212,  219,
			  219,  219,  239,  239,  239,  239,  239,  239,  242,  242,
			  242,  219,  175,  250,  219,  219,  219,  219,  219,  219,
			  242,  249,  249,  249,  250,  252,  172,  166,  160,  251,

			  251,  251,  158,  249,  154,  151,  252,  219,  224,  224,
			  224,  251,  255,  255,  255,  255,  255,  255,  140,  109,
			  224,  107,  103,  224,  224,  224,  224,  224,  224,  256,
			  256,  256,  256,  256,  256,  257,  257,  257,  257,  257,
			  257,  387,  387,  387,  387,  101,  224,  225,  225,  225,
			   97,  225,  258,  258,  258,  258,  258,  258,   89,  225,
			  260,  260,  260,  260,  260,  260,  264,  264,  264,  264,
			  264,  264,  266,  266,  266,  276,  267,  267,  267,  225,
			  267,   83,   82,   81,  266,  266,  276,   74,  267,   70,
			  225,  226,  226,  226,  226,  226,  226,  226,  228,  228,

			  228,  228,  228,  228,  228,  253,  253,  253,  277,   68,
			  266,  272,  272,  272,  272,  272,  272,  253,  302,  277,
			  253,  253,  253,  253,  253,  253,  275,  275,  275,  302,
			  388,  388,  388,  388,  253,  254,  254,  254,  275,  284,
			  284,  284,  284,  284,  284,   43,   39,  254,   38,   30,
			  254,  254,  254,  254,  254,  254,   17,    0,  285,  285,
			  285,  290,  290,  290,  290,  290,  290,    0,    0,    0,
			  285,    0,    0,  254,  259,  259,  259,  291,  291,  291,
			  291,  291,  291,  301,  301,  301,  259,  285,    0,  259,
			  259,  259,  259,  259,  259,  301,  285,  293,  293,  293,

			  293,  293,  293,    0,  296,  296,  296,    0,  296,    0,
			    0,    0,  259,  263,  263,  263,  296,  305,  305,  305,
			  305,  305,  305,    0,    0,  263,    0,    0,  263,  263,
			  263,  263,  263,  263,    0,  306,  306,  306,  307,  307,
			  307,  307,  307,  307,  377,  377,  377,  306,    0,  377,
			  377,  263,  265,  265,  265,  313,  313,  313,  313,  313,
			  313,    0,    0,    0,  265,    0,    0,  265,  265,  265,
			  265,  265,  265,  306,  314,  314,  314,  315,  315,  315,
			    0,  265,  283,  283,  283,    0,  314,    0,  315,  315,
			  389,  389,  389,  389,  283,    0,    0,  283,  283,  283,

			  283,  283,  283,  314,  316,  316,  316,  316,  316,  316,
			    0,    0,  314,  317,  317,  317,  317,  317,  317,    0,
			  283,  286,  286,  286,  327,  327,  327,  327,  327,  327,
			  324,  324,  324,  286,  324,    0,  286,  286,  286,  286,
			  286,  286,  324,  326,  326,  326,  390,  390,  390,  390,
			  286,  289,  289,  289,    0,  326,  329,  329,  329,  329,
			  329,  329,    0,  289,    0,    0,  289,  289,  289,  289,
			  289,  289,    0,  330,  330,  330,  335,  335,  335,    0,
			    0,  326,    0,    0,    0,  330,    0,    0,  335,  289,
			  292,  292,  292,  331,  331,  331,  331,  331,  331,    0,

			    0,    0,  292,    0,    0,  292,  292,  292,  292,  292,
			  292,  330,    0,    0,  335,  337,  337,  337,  337,  337,
			  337,  338,  338,  338,  338,  338,  338,    0,  292,  295,
			  295,  295,  345,  345,  345,  345,  345,  345,    0,    0,
			    0,  295,    0,    0,  295,  295,  295,  295,  295,  295,
			  344,  344,  344,  366,  366,  366,    0,    0,  295,  312,
			  312,  312,  344,    0,  366,  391,  391,  391,  391,    0,
			    0,  312,    0,    0,  312,  312,  312,  312,  312,  312,
			  383,  383,    0,    0,  383,  383,  383,    0,  344,  384,
			  384,    0,    0,  384,  384,  384,    0,  312,  321,  321,

			  321,  394,  394,    0,    0,  394,  394,  394,    0,    0,
			  321,    0,    0,  321,  321,  321,  321,  321,  321,  395,
			  395,  395,  395,  396,  396,  396,  396,  321,  397,  397,
			  397,  397,  399,  399,  399,  399,  321,  328,  328,  328,
			  402,  402,    0,    0,  402,  402,  402,    0,    0,  328,
			    0,    0,  328,  328,  328,  328,  328,  328,  403,  403,
			    0,    0,  403,  403,  403,  406,  406,    0,    0,  406,
			  406,  406,    0,    0,    0,  328,  339,  339,  339,  407,
			  407,    0,    0,  407,  407,  407,    0,    0,  339,    0,
			    0,  339,  339,  339,  339,  339,  339,  408,  408,    0,

			    0,  408,  408,  408,  409,  409,    0,    0,  409,  409,
			  409,    0,    0,    0,  339,  341,  341,  341,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  341,    0,    0,
			  341,  341,  341,  341,  341,  341,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  341,  346,  346,  346,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  346,    0,    0,  346,
			  346,  346,  346,  346,  346,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  346,  349,  349,  349,    0,    0,    0,    0,

			    0,    0,    0,    0,    0,  349,    0,    0,  349,  349,
			  349,  349,  349,  349,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  349,  352,  352,  352,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,  352,    0,    0,  352,  352,  352,
			  352,  352,  352,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  352,  354,  354,  354,  354,  354,  354,  354,  354,  354,
			  354,  354,  354,  354,  354,  354,  354,  354,  354,  354,
			  354,  354,  354,  354,  354,  355,  355,  355,  355,  355,

			  355,  355,  355,  355,  355,  355,  355,  355,  355,  355,
			  355,  355,  355,  355,  355,  355,  355,  355,  355,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  356,  356,  356,  356,  356,  356,  356,  356,  356,
			  356,  356,  356,  357,  357,  357,  357,  357,  357,  357,
			  357,  357,  357,  357,  357,  357,  357,  357,  357,  357,
			  357,  357,  357,  357,  357,  357,  357,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  358,  358,  358,  358,  358,  358,  358,  358,  358,
			  358,  359,  359,  359,  359,  359,  359,  359,  359,  359,

			  359,  359,  359,  359,  359,  359,  359,  359,  359,  359,
			  359,  359,  359,  359,  359,  360,  360,  360,  360,  360,
			  360,  360,  360,  360,  360,  360,  360,  360,  360,  360,
			  360,  360,  360,  360,  360,  360,  360,  360,  360,  361,
			  361,    0,  361,  361,  361,  361,  361,  361,  361,  361,
			  361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
			  361,  361,  361,  362,  362,  362,  362,    0,    0,  362,
			  362,  362,  362,  362,  362,  362,  362,  362,  362,  362,
			  362,  362,  362,  362,  362,  362,  362,  363,  363,  363,
			  363,    0,    0,  363,  363,  363,  363,  363,  363,  363,

			  363,  363,  363,  363,  363,  363,  363,  363,  363,  363,
			  363,  364,  364,    0,  364,  364,  364,  364,  364,  364,
			  364,  364,  364,  364,  364,  364,  364,  364,  364,  364,
			  364,  364,  364,  364,  364,  365,  365,  365,    0,    0,
			    0,    0,    0,  365,    0,    0,  365,  365,  365,    0,
			    0,  365,  365,  365,  365,  365,  365,  365,  367,  367,
			    0,  367,  367,  367,  367,  367,  367,  367,  367,  367,
			  367,  367,  367,  367,  367,  367,  367,  367,  367,  367,
			  367,  367,  368,  368,  368,  368,  368,  368,  368,  368,
			  368,  368,  368,  368,  368,  368,  368,  368,  368,  368,

			  368,  368,  368,  368,  368,  368,  369,  369,  369,  369,
			  369,  369,  369,  369,  369,  369,  369,  369,  369,  369,
			  369,  369,  369,  369,  369,  369,  369,  369,  369,  369,
			  370,  370,  370,  370,  370,  370,  370,  370,  370,  370,
			  370,  370,  370,  370,  370,  370,  370,  370,  370,  370,
			  370,  370,  370,  370,  371,  371,    0,  371,  371,  371,
			  371,  371,  371,  371,  371,  371,  371,  371,  371,  371,
			  371,  371,  371,  371,  371,  371,  371,  371,  372,  372,
			  372,  372,    0,    0,    0,  372,    0,    0,    0,  372,
			  372,  372,    0,    0,  372,  373,  373,  373,  373,    0,

			    0,  373,  373,  373,  373,  373,  373,    0,    0,    0,
			  373,  373,  374,  374,    0,  374,  374,  374,  374,  374,
			  374,  374,  374,  374,  374,  374,  374,  374,  374,  374,
			  374,  374,  374,  374,  374,  374,  375,  375,  375,  375,
			  375,  375,  375,  375,  375,  375,  375,  375,  375,  375,
			  375,  375,  375,  375,  375,  375,  375,  375,  375,  375,
			  376,  376,  376,  376,  376,  376,  376,  376,  376,  376,
			    0,  376,  376,  376,  376,  376,  376,  376,  376,  376,
			  376,  376,  376,  376,  378,  378,  378,  378,  378,  378,
			  378,  378,  378,  378,  378,  378,  378,  378,  378,  378,

			  378,  378,  378,  378,  378,  378,  378,  378,  379,  379,
			  379,  379,    0,    0,    0,  379,    0,    0,    0,  379,
			  379,  379,    0,    0,  379,  380,  380,  380,  380,  380,
			  380,  380,  380,  380,  380,  380,  380,  380,  380,  380,
			  380,  380,  380,  380,  380,  380,  380,  380,  380,  381,
			  381,    0,  381,  381,  381,  381,  381,  381,  381,  381,
			  381,  381,  381,  381,  381,  381,  381,  381,  381,  381,
			  381,  381,  381,  382,  382,  382,  382,    0,    0,  382,
			  382,  382,  382,  382,  382,  382,  382,  382,  382,  382,
			  382,  382,  382,  382,  382,  382,  382,  385,  385,  385,

			    0,    0,    0,    0,    0,  385,    0,    0,  385,  385,
			  385,    0,    0,    0,    0,    0,    0,    0,    0,  385,
			  392,  392,  392,  392,  392,  392,  392,  392,  392,  392,
			  392,  392,  392,  392,  392,  392,  392,  392,  392,  392,
			  392,  392,  392,  392,  393,  393,  393,  393,  393,  393,
			  393,  393,  393,  393,  393,  393,  393,  393,  393,  393,
			  393,  393,  393,  393,  393,  393,  393,  393,  398,  398,
			  398,  398,  398,  398,  398,  398,  398,  398,  398,  398,
			  398,  398,  398,  398,  398,  398,  398,  398,  398,  398,
			  398,  398,  400,  400,  400,  400,  400,  400,  400,  400,

			  400,  400,    0,  400,  400,  400,  400,  400,  400,  400,
			  400,  400,  400,  400,  400,  400,  401,  401,  401,  401,
			  401,  401,  401,  401,  401,  401,  401,  401,  401,  401,
			  401,  401,  401,  401,  401,  401,  401,  401,  401,  401,
			  404,  404,  404,  404,  404,  404,  404,  404,  404,  404,
			    0,  404,  404,  404,  404,  404,  404,  404,  404,  404,
			  404,  404,  404,  404,  405,  405,  405,  405,  405,  405,
			  405,  405,  405,  405,  405,  405,  405,  405,  405,  405,
			  405,  405,  405,  405,  405,  405,  405,  405,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,

			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353, yy_Dummy>>)
		end

	yy_base_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    0,    0,   44,   47,   49,   56,   63,   66,   73,
			   76,   79,   82,   85,   90,   50,   69,  956, 2388,   95,
			   98,  101,  110,  118,  104,  103,  123,  148,  132,  169,
			  913,  164,  139,  193,  199,  212,  217,  225,  910,  906,
			 2388,  230,  238,  931,  132, 2388,  243,  270, 2388,  152,
			 2388, 2388, 2388,  172, 2388, 2388,  175, 2388,  155,  314,
			 2388,  319, 2388,  245,  141, 2388,  219,  252,  895,  324,
			  875,  230,  327,  331,  871,  340,  258, 2388,  261,  347,
			 2388,  873,  866,  871,  352,  125,  357,  376, 2388,  844,
			  415,  430,  345,  397,    0,  465, 2388,  836,  165,  302,

			  400,  805,  406,  808,  255,  186,  424,  805, 2388,  805,
			 2388,  379, 2388,  382,  359,  422, 2388,  451, 2388, 2388,
			  419, 2388,  454, 2388,  366, 2388,  385, 2388,  458,  468,
			  472, 2388,  485,  492,  372, 2388,  402, 2388,  410, 2388,
			  804,  496,  509,  457,  501,  522, 2388, 2388,  499, 2388,
			  529,  795,  550,  533,  790,  536,  478,  549,  788, 2388,
			  784,  556,  417,  562, 2388, 2388,  783,  583,  495,  571,
			  577, 2388,  782,  552, 2388,  768,  622,  606,  582,  631,
			  513,  629,  626, 2388, 2388,  647,  751,  654,  728, 2388,
			  729,  675,  531, 2388,  727,  678,  677,  645,  684,  622,

			 2388,  705,  603,  708,  324,  599,  707,  549,  593,  608,
			  635,  666,  728,  696, 2388,  716,  528,  734,  740,  767,
			  228,  489, 2388,  547,  806,  845,  875,  528,  882,  498,
			  556,  474,  461,  596,  457, 2388,  431,  409,  399,  756,
			  396,  618,  776,  378,  363,  348,  341,  615,  336,  789,
			  780,  797,  792,  903,  933,  795,  812,  818,  835,  972,
			  843, 2388,  310, 1011,  849, 1050,  870,  874, 2388,  305,
			  234,  219,  895,  214,  196,  924,  872,  905,  656,  192,
			 2388,  190,  535, 1080,  922,  956, 1119, 2388,  171, 1149,
			  944,  960, 1188,  980,  544, 1227, 1002, 2388,  166,  130,

			 2388,  981,  915, 2388,  113, 1000, 1033, 1021, 2388,  100,
			  585,  677, 1257, 1038, 1072, 1075, 1087, 1096, 2388, 2388,
			   96, 1296,  707,   92, 1128, 2388, 1141, 1107, 1335, 1139,
			 1171, 1176,  726, 2388,   76, 1174, 2388, 1198, 1204, 1374,
			 2388, 1413, 2388,   49, 1248, 1215, 1452, 2388,   46, 1491,
			 2388,   42, 1530, 2388, 1570, 1594, 1618, 1642, 1666, 1690,
			 1714, 1738, 1762, 1786, 1810, 1833, 1240, 1857, 1881, 1905,
			 1929, 1953, 1973, 1994, 2011, 2035, 2059, 1031, 2083, 2103,
			 2124, 2148, 2172, 1271, 1280, 2195,  751,  829,  918, 1078,
			 1134, 1253, 2219, 2243, 1292, 1307, 1311, 1316, 2267, 1320,

			 2291, 2315, 1331, 1349, 2339, 2363, 1356, 1370, 1388, 1395, yy_Dummy>>)
		end

	yy_def_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,  353,    1,  354,  354,  355,  355,  356,  356,  357,
			  357,  358,  358,  359,  359,  360,  360,  353,  353,  353,
			  353,  353,  361,  362,  363,  364,  353,  353,  353,  353,
			   29,   29,  353,  353,  353,  353,  365,  365,  353,  366,
			  353,  353,  353,  353,  367,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  368,  368,
			  353,  368,  353,  369,  370,  353,  370,  353,  353,  353,
			  353,  361,  353,  371,  372,  361,  362,  353,  373,  363,
			  353,  353,  374,  353,  353,  375,  353,  353,  353,  353,
			  376,   29,   91,  353,  377,  353,  353,  353,   37,   37,

			  366,  366,  353,  353,  378,  367,  353,  379,  353,  353,
			  353,  353,  353,  353,  367,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  368,  353,  368,  353,  368,  368,
			  369,  353,  369,  353,  370,  353,  370,  353,  380,  353,
			  353,  353,  371,  381,  353,  361,  353,  353,  382,  353,
			  353,  353,  353,  353,  353,  353,  375,  353,  353,  353,
			  353,   87,  383,  353,  353,  353,  353,  353,  384,   91,
			  169,  353,  353,  377,  353,  353,  353,  385,   37,  353,
			  378,  353,  353,  353,  353,  353,  386,  353,  387,  353,
			  353,  353,  380,  353,  353,  353,  353,  388,  353,  389,

			  353,  353,  353,  353,  152,  390,  353,  391,  392,  393,
			  161,  353,  353,  353,  353,  167,  394,  353,  353,  353,
			  169,  170,  353,  353,  353,   37,  353,  395,  353,  396,
			  367,  387,  387,  387,  397,  353,  353,  389,  389,  353,
			  353,  398,  353,  353,  353,  391,  391,  391,  399,  353,
			  392,  353,  393,  353,  353,  353,  353,  215,  353,  353,
			  353,  353,  353,  353,  353,  400,  385,  353,  353,  353,
			  396,  396,  353,  353,  397,  353,  398,  401,  353,  399,
			  353,  353,  402,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  403,  404,  353,  353,  353,  405,

			  353,  353,  401,  353,  353,  353,  283,  353,  353,  353,
			  406,  407,  353,  353,  353,  403,  353,  353,  353,  353,
			  353,  353,  408,  405,  353,  353,  353,  353,  353,  353,
			  312,  353,  409,  353,  353,  353,  353,  321,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,    0,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353,

			  353,  353,  353,  353,  353,  353,  353,  353,  353,  353, yy_Dummy>>)
		end

	yy_ec_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    2,
			    3,    1,    1,    4,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    2,    5,    6,    7,    5,    8,    9,   10,
			   11,   11,   12,   13,    5,   14,   15,   16,   17,   18,
			   19,   20,   20,   21,   22,   22,   22,   22,   23,    5,
			   24,   25,   26,   27,    9,   28,   29,   30,   28,   31,
			   28,   32,   33,   32,   32,   32,   33,   32,   34,   35,
			   32,   33,   33,   33,   33,   33,   33,   32,   36,   32,
			   32,   37,   38,   39,    5,   40,    1,   41,   42,   43,

			   41,   31,   41,   32,   44,   32,   32,   32,   44,   32,
			   45,   35,   32,   44,   44,   44,   44,   44,   44,   32,
			   36,   32,   32,    5,    9,    5,    5,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    1,    1,    1, yy_Dummy>>)
		end

	yy_meta_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    2,    3,    4,    1,    5,    1,    6,    1,
			    7,    8,    1,    9,   10,   11,   12,   13,   13,   13,
			   13,   14,   15,    1,   16,    1,   17,    1,   18,   18,
			   18,   19,   20,   21,   21,   22,   23,    1,    1,    1,
			   24,   19,   19,   19,   22,   22, yy_Dummy>>)
		end

	yy_accept_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
			    1,    1,    1,    1,    2,    3,    4,    5,    6,    8,
			   12,   15,   18,   21,   24,   27,   30,   33,   36,   39,
			   45,   51,   57,   60,   63,   66,   69,   73,   77,   79,
			   81,   83,   87,   90,   92,   94,   96,   99,  101,  103,
			  105,  107,  110,  112,  114,  116,  118,  120,  122,  124,
			  126,  128,  130,  132,  134,  136,  138,  140,  142,  142,
			  144,  144,  145,  149,  150,  150,  152,  153,  154,  155,
			  156,  157,  158,  159,  161,  162,  163,  164,  168,  170,
			  170,  171,  175,  179,  181,  181,  183,  184,  184,  186,

			  188,  191,  192,  194,  194,  195,  196,  198,  198,  199,
			  199,  200,  201,  202,  203,  205,  207,  209,  209,  210,
			  211,  211,  212,  212,  213,  214,  215,  216,  217,  218,
			  219,  220,  222,  223,  226,  227,  228,  229,  231,  232,
			  234,  234,  240,  242,  243,  243,  244,  245,  246,  247,
			  248,  249,  250,  252,  254,  254,  255,  256,  258,  258,
			  260,  260,  264,  264,  264,  265,  267,  268,  272,  273,
			  277,  281,  282,  282,  284,  285,  285,  287,  289,  291,
			  292,  293,  293,  293,  294,  296,  297,  298,  299,  300,
			  301,  301,  302,  303,  306,  306,  308,  308,  308,  308,

			  308,  309,  311,  311,  312,  313,  314,  315,  316,  317,
			  318,  322,  322,  326,  326,  327,  331,  331,  331,  331,
			  335,  339,  343,  344,  344,  346,  348,  348,  348,  348,
			  348,  351,  352,  353,  354,  355,  356,  356,  356,  356,
			  356,  356,  357,  359,  359,  360,  361,  362,  363,  364,
			  365,  366,  367,  368,  370,  374,  374,  374,  378,  378,
			  386,  386,  388,  388,  392,  392,  393,  396,  397,  398,
			  398,  398,  398,  398,  398,  399,  400,  401,  402,  404,
			  405,  406,  406,  406,  410,  410,  412,  414,  418,  418,
			  426,  426,  426,  430,  430,  431,  432,  432,  434,  434,

			  435,  436,  437,  438,  439,  440,  440,  442,  442,  443,
			  443,  443,  443,  451,  451,  453,  455,  455,  455,  456,
			  458,  459,  461,  462,  462,  462,  463,  465,  465,  467,
			  467,  471,  471,  471,  472,  472,  474,  475,  477,  477,
			  479,  480,  482,  484,  484,  488,  488,  492,  493,  493,
			  495,  497,  497,  501,  501, yy_Dummy>>)
		end

	yy_acclist_template: SPECIAL [INTEGER] is
		once
			Result := yy_fixed_array (<<
			    0,   48,   48,   51,   51,  102,  100,  101,   95,   96,
			  100,  101,   95,   96,  101,    1,  100,  101,   54,  100,
			  101,   13,  100,  101,   17,  100,  101,   35,  100,  101,
			    1,  100,  101,    1,  100,  101,    1,  100,  101,   75,
			   79,  100,  101, -177, -181,   75,   79,  100,  101, -177,
			 -181,   75,   79,  100,  101, -177, -181,    1,  100,  101,
			    1,  100,  101,    1,  100,  101,    1,  100,  101,   11,
			  100,  101, -113,   11,  100,  101, -113,  100,  101,  100,
			  101,   99,  101,   97,   98,   99,  101,   97,   98,  101,
			   99,  101,   62,  101,   67,  101,   63,  101, -165,   66,

			  101,   72,  101,   72,  101,   71,  101,   70,   72,  101,
			   69,  101,   69,  101,   68,  101,   42,  101,   42,  101,
			   41,  101,   48,  101,   48,  101,   47,  101,   48,  101,
			   45,  101,   48,  101,   51,  101,   50,  101,   51,  101,
			   95,   96,    2,    3,   54,   38,   52, -140, -154,   54,
			   54, -141,   16,   18,   14,   17,   22,   35,   35,   34,
			   35,    2,   96,    5,   88,   94, -186, -192,  -76,  -80,
			 -184,   75,   79, -177, -181,   75,   79, -177, -181,   73,
			 -175,   79, -181,  -12,   11, -113,   11, -113,   78,   79,
			 -181,   78,   97,   98,   98,   62,   63, -165,  -64,   65,

			   65,   55,   65,   62,   65,   60,   65,   61,   65,   71,
			   70,   68,   41,   48,   47,   48,   45,   48,   48,   48,
			   46,   47,   48,   43,   45, -145,   51,   50,   51,   49,
			   50,    3,  -39,  -53,   36,   38,   52, -138, -140, -154,
			   54, -141,   54,   54,  -40,   21,   15,   19,   23,   35,
			   33,   35,    2,    4,   96,   96,    6,    7,  -85,  -91,
			   88,   94, -186, -192,   86,  -83,   86,   86,   88,   94,
			 -186, -192,   86,   75,   79, -177, -181,   75,   79, -177,
			 -181,  -74,   81, -183,  -80,   79, -181,   79, -181,   11,
			 -113,   98,   98,   56,   55,   56,   59,   59,   59,   59,

			  -44,    3,    3,  -37,  -39,  -53,   52, -154,   20,   24,
			   25,   26,   32,   32,   32,   32,    4,    7,   88,   94,
			 -186, -192,   88,   94, -186, -192,  -83,   88,   94, -186,
			 -192,   87,   93, -185, -191,   75,   79, -177, -181,   75,
			   79, -177, -181,  -82,   79, -181,   11, -113,   57,   58,
			   62,   59,   59,   59,   59,  -53,   25,   27,   28,   35,
			   32,   32,   32,   32,    4,    4,    7,    7,   88, -186,
			   88,   94, -186, -192,   88,   94, -186, -192,   87,   88,
			   93,   94, -185, -186, -191, -192,  -84,  -90,   87,   93,
			 -185, -191, -184,   77,   79, -181,  -12,    8,   59,   25,

			   25,   28,   29,   31,   32,  -85,   88,   94, -186, -192,
			   94, -192,   88, -186,  -84,  -85,  -90,  -91,   87,   88,
			   93,   94, -185, -186, -191, -192,   87,   93, -185, -191,
			   86, -190,    9,   10,  -12,   58,   28,   28,   30,   35,
			   88, -186,  -91,   87,   88,   93,   94, -185, -186, -191,
			 -192,   94, -192,   87, -185,   92,  -89,   92,   92,   94,
			 -192,   92,   31,   94, -192,   94, -192,   87,   88, -185,
			 -186,  -84,   93, -191,  -89,   94, -192,   93, -191,   10,
			   94, -192,  -84,  -85,   93,   94, -191, -192,   93,   94,
			 -191, -192,  -90,   93, -191,  -90,  -91,   93,   94, -191,

			 -192, yy_Dummy>>)
		end

feature {NONE} -- Constants

	yyJam_base: INTEGER is 2388
			-- Position in `yy_nxt'/`yy_chk' tables
			-- where default jam table starts

	yyJam_state: INTEGER is 353
			-- State id corresponding to jam state

	yyTemplate_mark: INTEGER is 354
			-- Mark between normal states and templates

	yyNull_equiv_class: INTEGER is 1
			-- Equivalence code for NULL character

	yyReject_used: BOOLEAN is false
			-- Is `reject' called?

	yyVariable_trail_context: BOOLEAN is true
			-- Is there a regular expression with
			-- both leading and trailing parts having
			-- variable length?

	yyReject_or_variable_trail_context: BOOLEAN is true
			-- Is `reject' called or is there a
			-- regular expression with both leading
			-- and trailing parts having variable length?

	yyNb_rules: INTEGER is 101
			-- Number of rules

	yyEnd_of_buffer: INTEGER is 102
			-- End of buffer rule code

	yyLine_used: BOOLEAN is true
			-- Are line and column numbers used?

	yyPosition_used: BOOLEAN is false
			-- Is `position' used?

	INITIAL: INTEGER is 0
	BREAK: INTEGER is 1
	MS: INTEGER is 2
	MSN: INTEGER is 3
	MSN1: INTEGER is 4
	VS1: INTEGER is 5
	VS2: INTEGER is 6
	VS3: INTEGER is 7
			-- Start condition codes

feature -- User-defined features



feature -- Scanning

	read_token is
			-- (NOTE: THIS IS THE COPY/PASTE VERSION OF THE CODE IN
			-- THE YY_COMPRESSED_SCANNER_SKELETON CLASS, FOR OPTIMISATION
			-- WITH ISE EIFFEL (ALLOW INLINING NOT POSSIBLE IN
			-- YY_COMPRESSED_SCANNER_SKELETON).)

			-- Read a token from `input_buffer'.
			-- Make result available in `last_token'.
		local
			yy_cp, yy_bp: INTEGER
			yy_current_state: INTEGER
			yy_next_state: INTEGER
			yy_matched_count: INTEGER
			yy_act: INTEGER
			yy_goto: INTEGER
			yy_c: INTEGER
			yy_found: BOOLEAN
			yy_rejected_line: INTEGER
			yy_rejected_column: INTEGER
			yy_rejected_position: INTEGER
			yy_done: BOOLEAN
		do
				-- This routine is implemented with a loop whose body
				-- is a big inspect instruction. This is a mere
				-- translation of C gotos into Eiffel. Needless to
				-- say that I'm not very proud of this piece of code.
				-- However I performed some benchmarks and the results
				-- were that this implementation runs amazingly faster
				-- than an alternative implementation with no loop nor
				-- inspect instructions and where every branch of the
				-- old inspect instruction was written in a separate
				-- routine. I think that the performance penalty is due
				-- to the routine call overhead and the depth of the call
				-- stack. Anyway, I prefer to provide you with a big and
				-- ugly but fast scanning routine rather than a nice and
				-- slow version. I hope you won't blame me for that! :-)
			from
				last_token := yyUnknown_token
				yy_goto := yyNext_token
			until
				last_token /= yyUnknown_token
			loop
				inspect yy_goto
				when yyNext_token then
					if yy_more_flag then
						yy_more_len := yy_end - yy_start
						yy_more_flag := False
					else
						yy_more_len := 0
						line := yy_line
						column := yy_column
						position := yy_position
					end
					yy_cp := yy_end
						-- `yy_bp' is the position of the first
						-- character of the current token.
					yy_bp := yy_cp
						-- Find the start state.
					-- START INLINING 'yy_at_beginning_of_line'
					-- yy_current_state := yy_start_state + yy_at_beginning_of_line
					if input_buffer.beginning_of_line then
						yy_current_state := yy_start_state + 1
					else
						yy_current_state := yy_start_state
					end
					-- END INLINING 'yy_at_beginning_of_line'
					if yyReject_or_variable_trail_context then
							-- Set up for storing up states.
						yy_state_stack.put (yy_current_state, 0)
						yy_state_count := 1
					end
					yy_goto := yyMatch
				when yyMatch then
						-- Find the next match.
					from
						yy_done := False
					until
						yy_done
					loop
						if yy_ec /= Void then
							if yy_content_area /= Void then
								yy_c := yy_ec.item (yy_content_area.item (yy_cp).code)
							else
								yy_c := yy_ec.item (yy_content.item (yy_cp).code)
							end
						else
							if yy_content_area /= Void then
								yy_c := yy_content_area.item (yy_cp).code
							else
								yy_c := yy_content.item (yy_cp).code
							end
						end
						if
							not yyReject_or_variable_trail_context and then
							yy_accept.item (yy_current_state) /= 0
						then
								-- Save the backing-up info before computing
								-- the next state because we always compute one
								-- more state than needed - we always proceed
								-- until we reach a jam state.
							yy_last_accepting_state := yy_current_state
							yy_last_accepting_cpos := yy_cp
						end
						from until
							yy_chk.item (yy_base.item (yy_current_state) + yy_c) = yy_current_state
						loop
							yy_current_state := yy_def.item (yy_current_state)
							if
								yy_meta /= Void and then
								yy_current_state >= yyTemplate_mark
							then
									-- We've arranged it so that templates are
									-- never chained to one another. This means
									-- we can afford to make a very simple test
									-- to see if we need to convert to `yy_c''s
									-- meta-equivalence class without worrying
									-- about erroneously looking up the meta
									-- equivalence class twice.
								yy_c := yy_meta.item (yy_c)
							end
						end
						yy_current_state := yy_nxt.item (yy_base.item (yy_current_state) + yy_c)
						if yyReject_or_variable_trail_context then
							yy_state_stack.put (yy_current_state, yy_state_count)
							yy_state_count := yy_state_count + 1
						end
						yy_cp := yy_cp + 1
						yy_done := (yy_current_state = yyJam_state)
					end
					if not yyReject_or_variable_trail_context then
							-- Do the guaranteed-needed backing up
							-- to find out the match.
						yy_cp := yy_last_accepting_cpos
						yy_current_state := yy_last_accepting_state
					end
					yy_goto := yyFind_action
				when yyFind_action then
						-- Find the action number.
					if not yyReject_or_variable_trail_context then
						yy_act := yy_accept.item (yy_current_state)
						yy_goto := yyDo_action
					else
						yy_state_count := yy_state_count - 1
						yy_current_state := yy_state_stack.item (yy_state_count)
						yy_lp := yy_accept.item (yy_current_state)
						yy_goto := yyFind_rule
					end
				when yyFind_rule then
						-- We branch here when backing up.
					check reject_used: yyReject_or_variable_trail_context end
					from yy_found := False until yy_found loop
						if
							yy_lp /= 0 and
							yy_lp < yy_accept.item (yy_current_state + 1)
						then
							yy_act := yy_acclist.item (yy_lp)
							if yyVariable_trail_context then
								if
									yy_act < - yyNb_rules or
									yy_looking_for_trail_begin /= 0
								then
									if yy_act = yy_looking_for_trail_begin then
										yy_looking_for_trail_begin := 0
										yy_act := - yy_act - yyNb_rules
										yy_found := True
									else
										yy_lp := yy_lp + 1
									end
								elseif yy_act < 0 then
									yy_looking_for_trail_begin := yy_act - yyNb_rules
									if yyReject_used then
											-- Remember matched text in case
											-- we back up due to `reject'.
										yy_full_match := yy_cp
										yy_full_state := yy_state_count
										yy_full_lp := yy_lp
									end
									yy_lp := yy_lp + 1
								else
									yy_full_match := yy_cp
									yy_full_state := yy_state_count
									yy_full_lp := yy_lp
									yy_found := True
								end
							else
								yy_full_match := yy_cp
								yy_found := True
							end
						else
							yy_cp := yy_cp - 1
							yy_state_count := yy_state_count - 1
							yy_current_state := yy_state_stack.item (yy_state_count)
							yy_lp := yy_accept.item (yy_current_state)
						end
					end
					yy_rejected_line := yy_line
					yy_rejected_column := yy_column
					yy_rejected_position := yy_position
					yy_goto := yyDo_action
				when yyDo_action then
						-- Set up `text' before action.
					yy_bp := yy_bp - yy_more_len
					yy_start := yy_bp
					yy_end := yy_cp
					debug ("GELEX")
					end
					yy_goto := yyNext_token
						-- Semantic actions.
					if yy_act = 0 then
							-- Must back up.
						if not yyReject_or_variable_trail_context then
								-- Backing-up info for compressed tables is
								-- taken after `yy_cp' has been incremented
								-- for the next state.
							yy_cp := yy_last_accepting_cpos
							yy_bp := yy_bp + yy_more_len
							yy_current_state := yy_last_accepting_state
							yy_goto := yyFind_action
						else
							last_token := yyError_token
							fatal_error ("fatal scanner internal error: no action found")
						end
					elseif yy_act = yyEnd_of_buffer then
							-- Amount of text matched not including
							-- the EOB character.
						yy_matched_count := yy_cp - yy_bp - 1
							-- Note that here we test for `yy_end' "<="
							-- to the position of the first EOB in the buffer,
							-- since `yy_end' will already have been 
							-- incremented past the NULL character (since all
							-- states make transitions on EOB to the 
							-- end-of-buffer state). Contrast this with the
							-- test in `read_character'.
						if yy_end <= input_buffer.count + 1 then
								-- This was really a NULL character.
							yy_end := yy_bp + yy_matched_count
							yy_current_state := yy_previous_state
								-- We're now positioned to make the NULL
								-- transition. We couldn't have
								-- `yy_previous_state' go ahead and do it
								-- for us because it doesn't know how to deal
								-- with the possibility of jamming (and we
								-- don't want to build jamming into it because
								-- then it will run more slowly).
							yy_next_state := yy_null_trans_state (yy_current_state)
							yy_bp := yy_bp + yy_more_len
							if yy_next_state /= 0 then
									-- Consume the NULL character.
								yy_cp := yy_end + 1
								yy_end := yy_cp
								yy_current_state := yy_next_state
								yy_goto := yyMatch
							else
								if yyReject_or_variable_trail_context then
										-- Still need to initialize `yy_cp',
										-- though `yy_current_state' was set
										-- up by `yy_previous_state'.
									yy_cp := yy_end
										-- Remove the state which was inserted
										-- in `yy_state_stack' by the call to
										-- `yy_null_trans_state'.
									yy_state_count := yy_state_count - 1
								else
										-- Do the guaranteed-needed backing up
										-- then figure out the match.
									yy_cp := yy_last_accepting_cpos
									yy_current_state := yy_last_accepting_state
								end
								yy_goto := yyFind_action
							end
						else
								-- Do not take the EOB character
								-- into account.
							yy_end := yy_end - 1
							yy_refill_input_buffer
							if input_buffer.filled then
								yy_current_state := yy_previous_state
								yy_cp := yy_end
								yy_bp := yy_start + yy_more_len
								yy_goto := yyMatch
							elseif
								yy_end - yy_start - yy_more_len /= 0
							then
									-- Some text has been matched prior to
									-- the EOB. First process it.
								yy_current_state := yy_previous_state
								yy_cp := yy_end
								yy_bp := yy_start + yy_more_len
								yy_goto := yyFind_action
							else
									-- Only the EOB character has been matched, 
									-- so treat this as a final EOF.
								if wrap then
									yy_bp := yy_start
									yy_cp := yy_end
									yy_execute_eof_action ((yy_start_state - 1) // 2)
								end
							end
						end
					else
						yy_execute_action (yy_act)
						if yy_rejected then
							yy_rejected := False
							yy_line := yy_rejected_line
							yy_column := yy_rejected_column
							yy_position := yy_rejected_position
								-- Restore position backed-over text.
							yy_cp := yy_full_match
							if yyVariable_trail_context then
									-- Restore original accepting position.
								yy_lp := yy_full_lp
									-- Restore original state.
								yy_state_count := yy_full_state
									-- Restore current state.
								yy_current_state := yy_state_stack.item (yy_state_count - 1)
							end
							yy_lp := yy_lp + 1
							yy_goto := yyFind_rule
						end
					end
				end
			end
			debug ("GELEX")
				print_last_token
			end
		end

end
