indexing

	description:

		"Objects that represent a public entry in an XM_CATALOG"

	library: "Gobo Eiffel XML Library"
	copyright: "Copyright (c) 2004, Colin Adams and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2004/09/12 05:43:10 $"
	revision: "$Revision: 1.1 $"

class XM_PUBLIC_CATALOG_ENTRY

inherit

	XM_CATALOG_ENTRY
		rename
			make as make_core
		end

creation

	make

feature {NONE} -- Initialization

	make (a_target_uri: UT_URI; a_prefer_public: BOOLEAN) is
			-- Establish invariant.
		require
			target_uri_not_void: a_target_uri /= Void and then a_target_uri.is_absolute
		do
			prefer_public := a_prefer_public
			make_core (a_target_uri)
		ensure
			prefer_public_set: prefer_public = a_prefer_public
			target_set: target_uri = a_target_uri
		end

feature -- Access

	prefer_public: BOOLEAN
			-- Was prefer="public" in effect when this entry was encountered?

end
	
