indexing

	description:

		"Objects that ignore trace events"

	library: "Gobo Eiffel XSLT Library"
	copyright: "Copyright (c) 2005, Colin Adams and others"
	license: "Eiffel Forum License v2 (see forum.txt)"
	date: "$Date: 2005/05/12 06:03:42 $"
	revision: "$Revision: 1.1 $"

class XM_XSLT_NULL_TRACE_LISTENER

inherit

	XM_XSLT_TRACE_LISTENER

	XM_XSLT_TRACE_CONSTANTS

	XM_XPATH_NAME_UTILITIES

	XM_XPATH_STANDARD_NAMESPACES

	XM_XPATH_SHARED_NAME_POOL

	DT_SHARED_SYSTEM_CLOCK

	KL_IMPORTED_STRING_ROUTINES

		-- This class is used to measure the impact of tracing, ignoring the I/O aspect.

creation

	make

feature {NONE} -- Initialization

	make is
			-- Do nothing.
		do
		end

feature -- Status report

	is_tracing: BOOLEAN
			-- Is tracing active?

feature -- Events

	start_tracing is
			-- Start tracing.
		do
			is_tracing := True
		end

	stop_tracing is
			-- Stop tracing.
		do
			is_tracing := False
		end

	trace_instruction_entry (some_trace_details: XM_XSLT_TRACE_DETAILS) is
			--  Trace start of instruction execution.
		do
		end

	trace_instruction_exit (some_trace_details: XM_XSLT_TRACE_DETAILS) is
			--  Trace end of instruction execution.
		do
		end

	trace_current_item_start (a_current_item: XM_XPATH_ITEM) is
			-- Trace making new item current.
		do
		end

	trace_current_item_finish (a_current_item: XM_XPATH_ITEM) is
			-- Trace leaving current item.
		do
		end

	trace_user_entry (a_value, a_label: STRING) is
			-- Trace user entry (e.g. XPath trace() function).
		do
		end

end

